#define IN_BUF_SIZE 16000
#define OUT_BUF_SIZE 16000
#define DECODE_SIZE 4096
#define NOT_SELECTED 0

#include <fcntl.h>
#include <gtk/gtk.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#include "mpglib/mpg123.h"
#include "mpglib/mpglib.h"
#include "common.h"

void execute (int nummer, float begin);
int search_in_file (struct mp3now *tmp,int num_bytes);
struct mpfile *init_file (char *filename);
void init_dsp();
int getfilesize (int filedes);
void zelfmoord ();

char buf[IN_BUF_SIZE+5];
	char in_buf[16005];
int bsize;
int dsp_fd;

void execute (int nummer, float begin)
{
	struct mpstr mp;
	int size;
	char out[OUT_BUF_SIZE+5];
	int len,ret;
	int status;
	int dummy;
	int pijpdata[2];
	struct mp3info *temp;
	
	if (pid != 0) {
		kill (pid, 18);
		kill (pid, 15);
		dummy = waitpid(pid, &status, 0);
		pid = 0;
	}

	pid = fork();
	if (pid == 0) {
		temp  = gtk_clist_get_row_data (GTK_CLIST(playlist), nummer);
		cur->filedes = open (temp->filename, O_RDONLY);
		cur->filesize = getfilesize(cur->filedes);
		size = DECODE_SIZE; 
		InitMP3(&mp);
		if (begin != 0) if (search_in_file (cur, cur->filesize * begin) == MP3_ERR) zelfmoord();
		cur->bytes_done = cur->filesize * begin;
		while(1) {
			len = read(cur->filedes, buf, IN_BUF_SIZE);
			cur->bytes_done = cur->bytes_done + len;
			pijpdata[0] = cur->filesize;
			pijpdata[1] = cur ->bytes_done;
			write(pijp[1], pijpdata, 2*sizeof (int));
			if(len <= 0) zelfmoord();
			ret = decodeMP3(&mp,buf,len,out,OUT_BUF_SIZE,&size);
			while(ret == MP3_OK) {
				write(dsp_fd,out,size);
				ret = decodeMP3(&mp,NULL,0,out,OUT_BUF_SIZE,&size);
			}
			if (ret == MP3_ERR) {
				if (search_in_file (cur, cur->bytes_done+100) == MP3_ERR) zelfmoord();
				ExitMP3 (&mp);
				InitMP3 (&mp);
			}
		}
	}
}

/* This function lets you set the filepointer in an mp3 */
int search_in_file (struct mp3now *tmp,int num_bytes)
{
	unsigned char buffer[2], reference[2];
	int i=0,j=0;
	if (num_bytes>=tmp->filesize) return MP3_ERR;
	lseek (tmp->filedes, 0, SEEK_SET);
	read (tmp->filedes, reference,2);
	lseek (tmp->filedes, num_bytes ,SEEK_SET);
	while(1) {
		if (i+num_bytes+5 >= tmp->filesize) return MP3_ERR;
		read (tmp->filedes, buffer, 2);
		i+=2;
		if (buffer[0] == 255 && buffer[1] >= 224) {
			if (i-j-2 == 418 || i-j-2 == 417) {
				lseek (tmp->filedes, -2, SEEK_CUR);
				break;
			}
			j=i-2;	
		}
		i--;
		lseek (tmp->filedes,-1,SEEK_CUR);
	}
	return MP3_OK;
}


/* this function opens /dev/dsp */
/* it currently only supports standard values */
void init_dsp()
{
	int i, p;
	int bsize;
	dsp_fd = open("/dev/dsp", O_WRONLY, 0);
	if (dsp_fd ==-1) printf("WARNING : unable to open /dev/dsp\n");
	ioctl(dsp_fd, SNDCTL_DSP_RESET, 0);
	p =  16; /* file_info->depth;*/
	i =  ioctl(dsp_fd, SOUND_PCM_WRITE_BITS, &p);
	p =  2; /* file_info->chans;  channels??*/
	i += ioctl(dsp_fd, SOUND_PCM_WRITE_CHANNELS, &p);
	p =  44100; /* file_info->srate;*/
	i += ioctl(dsp_fd, SOUND_PCM_WRITE_RATE, &p);
	i += ioctl(dsp_fd, SNDCTL_DSP_GETBLKSIZE, &bsize);
	ioctl(dsp_fd, SNDCTL_DSP_SYNC, 0);
}

int getfilesize (int filedes)
{
	struct stat *status;
	fstat (filedes, status);
	return status -> st_size;
}

void zelfmoord ()
{
	int pijpdata [2];
	pijpdata[0]= -1;  /* sending -1 as filesize to the main thread means : kill me! kill me! */
	write(pijp[1], pijpdata, 2*sizeof (int));
	for (;;);
	return;
}
	
